:_content-type: PROCEDURE
:navtitle: Git with self-signed certificates
:description: Deploying {prod-short} with support for Git repositories with self-signed certificates
:keywords: administration guide, deploying-che-with-support-for-git-repositories-with-self-signed-certificates
:page-aliases: installation-guide:deploying-che-with-support-for-git-repositories-with-self-signed-certificates

[id="deploying-{prod-id-short}-with-support-for-git-repositories-with-self-signed-certificates_{context}"]
= Deploying {prod-short} with support for Git repositories with self-signed certificates

You can configure {prod-short} to support operations on Git providers that use self-signed certificates.

.Prerequisites

* An active `oc` session with administrative permissions to the OpenShift cluster. See link:https://docs.openshift.com/container-platform/{ocp4-ver}/cli_reference/openshift_cli/getting-started-cli.html[Getting started with the OpenShift CLI].

* Git version 2 or later

.Procedure

. Create a new *ConfigMap* with details about the Git server:
+
[subs="+quotes,+attributes"]
----
$ {orch-cli} create configmap che-git-self-signed-cert \
  --from-file=ca.crt=__<path_to_certificate>__ \  <1>
  --from-literal=githost=__<host:port>__ -n {prod-namespace}  <2>
----
<1> Path to self-signed certificate
<2> The host and port of the HTTPS connection on the Git server (optional).
+
[NOTE]
====
* When `githost` is not specified, the given certificate is used for all HTTPS repositories.
* Certificate files are typically stored as Base64 ASCII files, such as. `.pem`, `.crt`, `.ca-bundle`. Also, they can be encoded as binary data, for example, `.cer`.  All `Secrets` that hold certificate files should use the Base64 ASCII certificate rather than the binary data certificate.
====

. Add the required labels to the ConfigMap:
+
[subs="+quotes,attributes"]
----
$ {orch-cli} label configmap che-git-self-signed-cert \
  app.kubernetes.io/part-of=che.eclipse.org -n {prod-namespace}
----

. Configure {prod-short} operand to use self-signed certificates for Git repositories. See xref:using-the-cli-to-configure-the-checluster-custom-resource.adoc[].
+
[source,yaml,subs="+attributes"]
----
spec:
  server:
    gitSelfSignedCert: true
----

.Verification steps

* Create and start a new workspace. Every container used by the workspace mounts a special volume that contains a file with the self-signed certificate. The repository's `.git/config` file contains information about the Git server host (its URL) and the path to the certificate in the `http` section (see Git documentation about link:https://git-scm.com/docs/git-config#Documentation/git-config.txt-httpsslCAInfo[git-config]).
+
.A `.git/config` file example
====
----
[http "https://10.33.177.118:3000"]
sslCAInfo = /etc/che/git/cert/ca.crt
----
====

.Additional resources

* xref:using-chectl-to-configure-the-checluster-custom-resource-during-installation.adoc[]

* xref:using-the-cli-to-configure-the-checluster-custom-resource.adoc[]

